---
schema_version: "1"
id: 84acdab5a66caaa94ecfa02cc3a31bed8a44ebba1b488011296a631cf517023b
title: Data Customer Groups (deprecated)
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/b2c-commerce/references/generated-api-specs/ocapi-data-customer-groups.md
canonical_url: https://developer.salesforce.com/docs/commerce/b2c-commerce/references/ocapi-data-customer-groups
source_site: developer.salesforce.com
content_type: documentation
content_hash: d40321cb23abdd18ada72902c62c2243e22a9b2587484e5fc6d8ff989c05ebcd
products:
  - B2C Commerce
  - Salesforce APIs
---
Data Customer Groups (deprecated)

# Data Customer Groups (deprecated)

Data API endpoints enable developers to build applications for merchants: Create, update, delete business objects, like products, customers, pricing and promotions or assignments. They typically provide read and write access and are designed for moderate usage.

**Version:** 25.6

## Servers

*   `https://{host}/s/-/dw/data/v25_6`

Protocols: https.

## Security

*   `oauth2_application` (oauth2) Authentication flow with client ID and password with account manager.
    *   OAuth flow application (tokenUrl: https://account.demandware.com:443/dwsso/oauth2/access\_token)
    *   Scope x-info: Scopes are NOT supported. This is just a dummy, because the 'scopes' field is required.
*   `client_id` (apiKey) Add client ID for application identification. Alternative as 'client\_id' query parameter.
    *   API key in header: x-dw-client-id

## Operations

### GET Get Customer Groups

`GET /sites/{site_id}/customer_groups`

Operation ID: `Get Customer Groups`. Tags: sites. Security: oauth2\_application.

Action to get all the customer groups with no filtering.

#### Parameters

*   `site_id` (path, string, required) The site context.  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.

#### Responses

*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_groups`.
    

### GET Get Customer Group

`GET /sites/{site_id}/customer_groups/{id}`

Operation ID: `Get Customer Group`. Tags: sites. Security: oauth2\_application.

Action to get customer group information.

This endpoint may return the following faults:

*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested customer group.  
    Minimum length: 1.
*   `select` (query, string) The attribute selector. Include 'member\_count' explicitly if member count per customer group is required.

#### Responses

*   **404** `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group`.
    

### PUT Create Customer Group

`PUT /sites/{site_id}/customer_groups/{id}`

Operation ID: `Create Customer Group`. Tags: sites. Security: oauth2\_application.

Creates a customer group using the information provided.

This endpoint may return the following faults:

*   400 - CustomerGroupCreateException - Thrown when there are system error in creating the customer group.
*   400 - IdConflictException - Thrown when id in query parameter is different from the id in the body.
*   403 - SystemCustomerGroupCreateForbiddenException - Thrown when attempting to create the system customer group.
*   409 - CustomerGroupAlreadyExistsException - if a customer group exists already in the site with the given identifier.

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the customer group to create.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_group`.

#### Responses

*   **400** `CustomerGroupCreateException` - Thrown when there are system error in creating the customer group. or `IdConflictException` - Thrown when id in query parameter is different from the id in the body.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **403** `SystemCustomerGroupCreateForbiddenException` - Thrown when attempting to create the system customer group.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **409** `CustomerGroupAlreadyExistsException` - if a customer group exists already in the site with the given identifier.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group`.
    

### DELETE Delete Customer Group

`DELETE /sites/{site_id}/customer_groups/{id}`

Operation ID: `Delete Customer Group`. Tags: sites. Security: oauth2\_application.

Triggers customer group deletion by ID. Be aware that the deletion happens via asynchronous batch process which is the reason the deletion itself is not necessarily finished after the call to this resource returned. The customer group that is in deletion will be provided in the response.

This endpoint may return the following faults:

*   403 - SystemCustomerGroupDeleteForbiddenException - Thrown when attempting to delete the system customer group.

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) One customer group id to remove
*   `select` (query, string) The attribute selector for the customer group which is now in deletion

#### Responses

*   **403** `SystemCustomerGroupDeleteForbiddenException` - Thrown when attempting to delete the system customer group.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group`.
    

### PATCH Update Customer Group

`PATCH /sites/{site_id}/customer_groups/{id}`

Operation ID: `Update Customer Group`. Tags: sites. Security: oauth2\_application.

Updates the customer group with the specified information.

This endpoint may return the following faults:

*   403 - SystemCustomerGroupUpdateForbiddenException - Thrown when attempting to update the system customer group.
*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested customer group.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `customer_group`.

#### Responses

*   **403** `SystemCustomerGroupUpdateForbiddenException` - Thrown when attempting to update the system customer group.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group`.
    

### POST Search CustomerGroupMembers

`POST /sites/{site_id}/customer_groups/{id}/member_search`

Operation ID: `Search CustomerGroupMembers`. Tags: sites. Security: oauth2\_application.

Searches for customer group members. For dynamic customer groups and the system groups "Everyone" and "Unregistered" no result is returned (Status Code: 204 - No Content).

The query attribute specifies a complex query that can be used to narrow down the search. Attributes are grouped into different buckets. These are the list of searchable attributes with their corresponding buckets:

Main:

*   login - String
    
*   active - Boolean
    

Customer Profile:

*   customer\_no - String
    
*   first\_name - String
    
*   last\_name - String
    
*   email - String
    
*   zip - String
    

Only attributes in the same bucket can be joined using a disjunction (OR). For instance, when joining login and customer\_no above, only a conjunction is allowed (AND), whereas customer\_no and email can be joined using a disjunction because they are in the same bucket. If an attribute is used in a disjunction (OR) that violates this rule, an exception will be thrown.

The output of the query can also be sorted. These are the list of sortable attributes:

*   customer\_no - String
    
*   login - String
    

If the Business manager customer search is configured to use the new Search Service, the following differences apply:

*   all attributes can be used for sorting (except for 'active')
    
*   searching for 'zip' will only search in the customers default address
    
*   logical operators can be used without limits (but may result in degraded performance, depending on how they are combined)
    
*   new assignments might not be found immediately via the search service, and removed assignments might also not be in effect immediately (there is a slight delay in updating the index)
    

This endpoint may return the following faults:

*   400 - MalformedSearchParameterException - Thrown if the query is ill-formed.
*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested members customer group.  
    Minimum length: 1.

#### Request body (required)

Media type: `application/json, text/xml`. Schema: `search_request`.

#### Responses

*   **400** `MalformedSearchParameterException` - Thrown if the query is ill-formed.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group_member_search_result`.
    

### GET Get Customer Group Members

`GET /sites/{site_id}/customer_groups/{id}/members`

Operation ID: `Get Customer Group Members`. Tags: sites. Security: oauth2\_application.

Action to get all the customer group members with no filtering. For dynamic customer groups and the system groups "Everyone" and "Unregistered" no result is returned (Status Code: 204 - No Content).

This endpoint may return the following faults:

*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id

#### Parameters

*   `site_id` (path, string, required)  
    Minimum length: 1.
*   `id` (path, string, required)  
    Minimum length: 1.
*   `start` (query, integer (int32)) Optional start index for retrieving the items from a given index (default 0).
*   `count` (query, integer (int32)) Optional count for retrieving only a subset of the items (default is 25).
*   `select` (query, string) The property selector.

#### Responses

*   **404** `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group_members`.
    

### GET Get CustomerGroupMember

`GET /sites/{site_id}/customer_groups/{id}/members/{customer_no}`

Operation ID: `Get CustomerGroupMember`. Tags: sites. Security: oauth2\_application.

Action to get customer group member information.

This endpoint may return the following faults:

*   404 - CustomerGroupMemberNotFoundException - Thrown in case the customer group member did not exist, or the group is not a static group
*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the requested members customer group.  
    Minimum length: 1.
*   `customer_no` (path, string, required) The customer number of the requested customer group member.  
    Minimum length: 1.
*   `select` (query, string) The selector for selective response content.

#### Responses

*   **404** `CustomerGroupMemberNotFoundException` - Thrown in case the customer group member did not exist, or the group is not a static group or `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group_member`.
    

### PUT Assign CustomerGroupMember to group

`PUT /sites/{site_id}/customer_groups/{id}/members/{customer_no}`

Operation ID: `Assign CustomerGroupMember to group`. Tags: sites. Security: oauth2\_application.

Action to add customer to (static) customer group.

This endpoint may return the following faults:

*   403 - CustomerGroupUnsupportedAssignmentException - Thrown when the customer group is not a static group.
*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id.
*   404 - CustomerNotFoundException - Thrown in case the customer list did not exist, or the customer does not exist in in the list.

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the customer group.  
    Minimum length: 1.
*   `customer_no` (path, string, required) The customer number of the customer to add to the group.  
    Minimum length: 1.
*   `select` (query, string) The selector for selective response content.

#### Responses

*   **403** `CustomerGroupUnsupportedAssignmentException` - Thrown when the customer group is not a static group.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id. or `CustomerNotFoundException` - Thrown in case the customer list did not exist, or the customer does not exist in in the list.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **default**
    
    Media type: `application/json, text/xml`. Schema: `customer_group_member`.
    

### DELETE Unassign CustomerGroupMember

`DELETE /sites/{site_id}/customer_groups/{id}/members/{customer_no}`

Operation ID: `Unassign CustomerGroupMember`. Tags: sites. Security: oauth2\_application.

Action to remove a customer from a (static) customer group.

This endpoint may return the following faults:

*   403 - CustomerGroupUnsupportedAssignmentException - Thrown when the customer group is not a static group.
*   404 - CustomerGroupNotFoundException - Thrown in case the customer group does not exist matching the given id.
*   404 - CustomerNotFoundException - Thrown in case the customer list did not exist, or the customer does not exist in the list.

#### Parameters

*   `site_id` (path, string, required) The id of the site.  
    Minimum length: 1.
*   `id` (path, string, required) The id of the customer group.  
    Minimum length: 1.
*   `customer_no` (path, string, required) The customer number of the customer to remove from the group.  
    Minimum length: 1.
*   `select` (query, string) The selector for selective response content.

#### Responses

*   **204**
*   **403** `CustomerGroupUnsupportedAssignmentException` - Thrown when the customer group is not a static group.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    
*   **404** `CustomerGroupNotFoundException` - Thrown in case the customer group does not exist matching the given id. or `CustomerNotFoundException` - Thrown in case the customer list did not exist, or the customer does not exist in the list.
    
    Media type: `application/json, text/xml`. Schema: `fault`.
    

## Schemas

### customer\_groups

Document representing an unfiltered list of customer groups.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of customer\_group_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "_resource_state": "c2309jd239jdrifj3ui4fn",
      "description": "Test group 1",
      "id": "test_customergroup_1",
      "link": "https://example.com/s/-/dw/data/{version}/sites/SiteGenesis/customer_groups/test_customergroup_1",
      "member_count": 5,
      "type": "static"
    },
    {
      "_resource_state": "82jhch39saxn23denx93e8",
      "description": "Test group 2",
      "id": "test_customergroup_2",
      "link": "https://example.com/s/-/dw/data/{version}/sites/SiteGenesis/customer_groups/test_customergroup_2",
      "member_count": 15,
      "type": "static"
    }
  ],
  "select": "**",
  "start": 0,
  "total": 2
}
```

### fault

Document representing a fault message that is returned whenever the HTTP status code is greater than or equal to 400 (which indicates an error).

*   `arguments` (_object_)
    
    A map that provides fault arguments.
    
    Data can be used to provide error messages on the client side.
    
    Additional properties: `object`.
    
*   `cause` (_cause_)
*   `display_message_pattern` (_string_) The localized display message pattern, if the request parameter display\_locale was given
*   `message` (_string_) The message text of the java exception.
*   `stack_trace` (_string_)
*   `type` (_string_) The name of the java exception.

### customer\_group

Document representing a customer group

*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `description` (_string_) The description for the customer group. This property is read-only for system groups.
*   `id` (_string_, read-only) The user specific identifier for the customer group, which must be unique across the organization. Property is read-only.  
    Minimum length: 1. Maximum length: 256.
*   `in_deletion` (_boolean_) The deletion status of this customer group.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `link` (_string_) URL that is used to get this instance. This property is computed and cannot be modified.
*   `member_count` (_integer (int32)_) The number of members in this customer group.
*   `rule` (_rule_) The rule of this customer group. Only available for dynamic customer groups.
*   `type` (_string_) The type of the customer group. This property is read-only.  
    Allowed values: `system`, `dynamic`, `static`.

_Example_

```
{
  "description": "Test group",
  "id": "test_customergroup1",
  "link": "https://example.com/s/-/dw/data/{version}/sites/SiteGenesis/customer_groups/test_customergroup1",
  "type": "dynamic"
}
```

### search\_request

Document representing a search request for retrieving items within the Data API. The query is a potentially complex set of expressions. The fields that each query supports are defined within the search resource.

*   `count` (_integer (int32)_) The number of returned documents  
    Minimum: 1. Maximum: 200.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `query` (_query_, required) The query to apply
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.

### customer\_group\_member\_search\_result

Document representing a customer group member search result.

*   `count` (_integer (int32)_) The number of returned documents
*   `data` (_array of object_)
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling  
    Minimum: 0.
*   `expand` (_array of string_) List of expansions to be applied to each search results. Expands are optional
*   `hits` (_array of customer\_group\_member_) The sorted array of search hits. Can be empty.
*   `next` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the next result page.
*   `previous` (_result\_page_) The data that can be used (as parameters on the search request) to retrieve the previous result page.
*   `query` (_query_) The query passed into the search
*   `select` (_string_) The field to be selected.
*   `sorts` (_array of sort_) The list of sort clauses configured for the search request. Sort clauses are optional.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The number of returned documents

_Example_

```
{
  "count": 1,
  "hits": [
    {
      "active": true,
      "customer_no": "0001",
      "email": "rhood@example.com",
      "first_name": "Robin",
      "last_name": "Hood",
      "link": "https://example.com/s/-/dw/data/{version}/sites/SiteGenesis/customer_groups/test_customergroup/members/test_customer",
      "login": "test_customer"
    }
  ],
  "query": {
    "term_query": {
      "fields": [
        "active"
      ],
      "operator": "is",
      "values": [
        true
      ]
    }
  },
  "start": 0,
  "total": 1
}
```

### customer\_group\_members

Document representing an unfiltered list of customer groups.

*   `count` (_integer (int32)_) The number of returned documents.
*   `data` (_array of customer\_group\_member_)
*   `expand` (_array of string_) The list of expands set for the search request. Expands are optional.
*   `next` (_string_) The URL of the next result page.
*   `previous` (_string_) The URL of the previous result page.
*   `select` (_string_) The fields that you want to select.
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.  
    Minimum: 0.
*   `total` (_integer (int32)_) The total number of documents.

_Example_

```
{
  "count": 2,
  "data": [
    {
      "active": true,
      "customer_link": "https://example.com/s/-/dw/data/{version}/customer_lists/SiteGenesis/customers/test_customer",
      "customer_no": "test_customer",
      "first_name": "John",
      "last_name": "Doe",
      "login": "test"
    },
    {
      "active": true,
      "customer_link": "https://example.com/s/-/dw/data/{version}/customer_lists/SiteGenesis/customers/bigshot_customer",
      "customer_no": "bigshot_customer",
      "first_name": "Big",
      "last_name": "Shot",
      "login": "bighsot"
    }
  ],
  "select": "**",
  "start": 0,
  "total": 2
}
```

### customer\_group\_member

Document representing a customer group member

*   `active` (_boolean_) A flag indicating whether the customer is enabled and can log in.
*   `creation_date` (_string (date-time)_, read-only) Returns the value of attribute 'creationDate'.
*   `customer_link` (_string_) The link to the customer resource.  
    Maximum length: 256.
*   `customer_no` (_string_) The customers number (id).  
    Maximum length: 100.
*   `email` (_string (email)_) The customer's email address.  
    Maximum length: 256.
*   `first_name` (_string_) The customer's first name.  
    Maximum length: 256.
*   `last_modified` (_string (date-time)_, read-only) Returns the value of attribute 'lastModified'.
*   `last_name` (_string_) The customer's last name.  
    Maximum length: 256.
*   `link` (_string_) The link to the customer group member resource.  
    Maximum length: 256.
*   `login` (_string_) The login of the customer.  
    Maximum length: 256.

_Example_

```
{
  "active": true,
  "customer_link": "https://example.com/s/-/dw/data/{version}/customer_lists/SiteGenesis/customers/test_customer",
  "customer_no": "test_customer",
  "first_name": "John",
  "last_name": "Doe",
  "login": "test"
}
```

### cause

*   `cause` (_cause_)
*   `message` (_string_)
*   `type` (_string_)

### rule

Document representing a customer group rule

*   `description` (_string_) The description of the rule, describing its conditions in natural language. Property is read-only.

_Example_

```
{
  "description": "'session.referrerURL' starts with [http://www.google.de]"
}
```

### query

Document representing a query. A query contains a set of objects that define criteria used to select records. A query can contain one of the following:

*   match\_all\_query - returns all records.
    
*   term\_query - matches records where a field (or fields) exactly match some simple value (including null).
    
*   text\_query - matches records where a field (or fields) contain a search phrase.
    
*   boolean\_query - formulates a complex boolean expression using query objects as criteria.
    
*   filtered\_query - allows for filtering of records based on both a query and a filter.
    

Type: `any`.

### sort

Document representing a sort request.

*   `field` (_string_, required) The name of the field to sort on.
*   `sort_order` (_string_) The sort order to be applied when sorting. When omitted, the default sort order (ASC) is used.  
    Allowed values: `asc`, `desc`.

_Example_

```
{
  "field": "id",
  "sort_order": "asc"
}
```

### result\_page

Data that can be used to get the next and previous page of a Data API results object.

*   `count` (_integer (int32)_) The number of returned documents.
*   `db_start_record_` (_integer (int32)_) The zero-based index of the record that we want to start with, used to optimize special handling
*   `start` (_integer (int32)_) The zero-based index of the first search hit to include in the result.

### bool\_filter

Document representing a boolean filter.

A boolean filter allows you to combine other filters into (possibly recursive) logical expression trees. A boolean filter is configured with a boolean operator (AND, OR, NOT) and a list of filters the operator relates to. If multiple filters are given to a boolean NOT operator, this is interpreted as a NOT upon a boolean OR of the given filters.

**Example:** (id="myId" AND coupon\_id="couponOne")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "and",
filters: \[
{ term\_filter: { field: "id", operator: "is", values: \["myId"\] } },
{ term\_filter: { field: "coupon\_id", operator: "is", values: \["couponOne"\] } }
\]
}
}
}
}

**Example:** (id="holidaySale" OR redemption\_count BETWEEN(1, 20)

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "or",
filters: \[
{ term\_filter: { field: "id", operator: "is", values: \["holidaySale"\] } },
{ range\_filter: { field: "redemption\_count", from: 1, to: 20 } }
\]
}
}
}
}

**Example:** NOT(enabled=false OR coupon\_id="special")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
bool\_filter: {
operator: "not",
filters: \[
{ term\_filter: { field: "enabled", operator: "is", values: \[false\] } },
{ term\_filter: { field: "coupon\_id", operator: "is", values: \["special"\] } }
\]
}
}
}
}

*   `filters` (_array of filter_) A list of filters, which are logically combined by an operator.
*   `operator` (_string_, required) The logical operator the filters are combined with.  
    Allowed values: `and`, `or`, `not`.

### bool\_query

A boolean query allows construction of full logical expression trees consisting of other queries (usually term and text queries). A boolean query basically has 3 sets of clauses that 'must', 'should' and / or 'must not' match. If 'must', 'must\_not', or 'should' appear in the same boolean query, they are combined logically using the AND operator. The difference between must and should operators is that the must operator requires all subqueries to match whereas the should operator only requires one match

**Example:** (id = 'foo' AND description LIKE 'bar')

query: {
bool\_query: {
must: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** (id = 'foo' OR description LIKE 'bar')

query: {
bool\_query: {
should: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** (NOT (id = 'foo' AND description LIKE 'bar'))

query: {
bool\_query: {
must\_not: \[
{ term\_query: { fields: \["id"\], operator: "is", values: \["foo"\] } },
{ text\_query: { fields: \["description"\], search\_phrase: "bar" } }
\]
}
}

**Example:** ((coupon\_id LIKE "limit" AND description LIKE "limit per customer") AND NOT (enabled=false))

query: {
bool\_query: {
must: \[
{ text\_query: { fields: \[ "coupon\_id" \], search\_phrase: "limit" } },
{ text\_query: { fields: \[ "description" \], search\_phrase: "limit per customer" } }
\],
must\_not: \[
{ term\_query: { fields: \[ "enabled" \], operator: "is", values: \[false\] } }
\]
}
}

*   `must` (_array of query_) List of queries that must match.
*   `must_not` (_array of query_) List of queries that must not match.
*   `should` (_array of query_) List of queries that should match (i.e., at least one query must match).

### filter

Document representing a filter.

A filter contains a set of objects that define criteria used to select records. A filter can contain one of the following:

*   term\_filter - matches records where a field (or fields) exactly match some simple value (including null).
    
*   range\_filter - matches records where a field value lies in a specified range.
    
*   query\_filter - provides filtering based on a query.
    
*   bool\_filter - provides filtering of records using a set of filters combined with a specified operator.
    

Type: `any`.

### filtered\_query

A filtered query allows to filter the result of a (possibly complex) query using a (possibly complex) filter.

**Example:**

query : {
filtered\_query: {
query: {
text\_query: { fields: \["coupon\_id"\], search\_phrase: "disabled" }
},
filter: {
term\_filter: {
field: "enabled", operator: "is", values: \[ false \]
}
}
}
}

*   `filter` (_filter_, required) The (possibly complex) filter object.
*   `query` (_query_, required) The query object.

### match\_all\_query

A match all query simply matches all documents (namespace and document type). This query comes in handy if you just want to filter a search result or really do not have any constraints.

**Example:**

query: {
match\_all\_query: {}
}

Type: `any`.

### nested\_query

A nested query queries nested documents that are part of a larger document. The classical example is a product master with variants (in one big document) where you want to constrain a search to masters that have variants that match multiple constraints (like color = blue AND size = M). This query is not compatible with some search types. **Example:** finds all the documents that has firstname = "John" and lastname = "Doe"

{
"query": {
"bool\_query": {
"must": \[
{
"nested\_query": {
"path": "order.shipping\_addresses",
"query": {
"bool\_query": {
"must": \[
{
"bool\_query": {
"must": \[
{
"term\_query": {
"fields": \[ "order.shipping\_addresses.first\_name" \],
"operator": "is",
"values": \[ "John" \]
}
}
\]
}
},
{
"bool\_query": {
"must": \[
{
"term\_query": {
"fields": \[ "order.shipping\_addresses.last\_name" \],
"operator": "is",
"values": \[ "Doe" \]
}
}
\]
}
}
\]
}
},
"score\_mode": "avg"
}
}
\]
}
}
}

*   `path` (_string_, required)
*   `query` (_query_, required)
*   `score_mode` (_string_)  
    Allowed values: `avg`, `total`, `max`, `none`.

### query\_filter

Document representing a query filter. A query filter wraps any query and allows it to be used as a filter.

**Example:** (coupon\_id contains "disabled" AND (enabled=false OR active=false))

query : {
filtered\_query: {
query: { text\_query: { fields: \["coupon\_id"\], search\_phrase: "disabled" } },
filter: {
query\_filter: {
query: {
term\_query: { fields: \["enabled","active"\], operator: "is", values: \[ false \] }
}
}
}
}
}

*   `query` (_query_, required) The query to use as a filter.

### range2\_filter

Document representing a range comparison with a range filter, named Range2Filter.

A Range2Filter allows you to restrict a search result to hits where a range defined by specified attributes has a certain relationship to a specified range.

The first range (R1) is defined by a pair of attributes ("from\_field" and "to\_field") that specify the extent of a range, such as the attributes "valid\_from" and "valid\_to".

The second range (R2) is defined by "from\_value" and "to\_value".

The filter mode specifies the method used to compare the two ranges:

*   overlap: R1 overlaps fully or partially with R2
    
*   containing: R1 contains R2
    
*   contained: R1 is contained in R2
    

The range filter supports several value types, and relies on the natural sorting of the value type for range interpretation. Value ranges can be open-ended (at one end only). You can configure whether the lower and upper bounds are inclusive or exclusive.

A range 2 filter is useful for general restrictions that can be shared between searches (like a static date range) because the filter result is cached in memory. Range filters are not appropriate if the range is expected to be different for every query (for example, if the user controls the date range down to the hour via a UI control). Range filters are inclusive by default.

**Example:** (valid dates overlap with the range January 1, 2007 through January 1, 2017)

"query" : {
"filtered\_query": {
"filter": {
"range2\_filter": {
"from\_field": "valid\_from",
"to\_field": "valid\_to",
"filter\_mode":"overlap",
"from\_value": "2007-01-01T00:00:00.000Z",
"to\_value": "2017-01-01T00:00:00.000Z"
}
},
"query": { "match\_all\_query": {} }
}
}

*   `filter_mode` (_string_) Compare mode: overlap, containing, or contained. If not specified, the default is overlap.  
    Allowed values: `overlap`, `containing`, `contained`.
*   `from_field` (_string_, required) The field name of the field that starts the first range.
*   `from_inclusive` (_boolean_) Indicates whether the lower bound of the second range is inclusive. If not specified, the default is true. Set to false to make the lower bound exclusive.
*   `from_value` (_object_) The lower bound of the second range. If not specified, the range is open-ended with respect to the lower bound. You can't leave both the lower and upper bounds open-ended.
*   `to_field` (_string_, required) The field name of the field that ends the first range.
*   `to_inclusive` (_boolean_) Indicates whether the upper bound of the second range is inclusive. If not specified, the default is true. Set to false to make the lower bound exclusive.
*   `to_value` (_object_) The upper bound of the second range. If not specified, the range is open-ended with respect to the upper bound. You can't leave both the upper and lower bounds open-ended.

### range\_filter

Document representing a range filter.

A range filter allows you to restrict a search result to hits that have values for a given attribute that fall into a given value range. The range filter supports several value types, and relies on the natural sorting of the value type for range interpretation. Value ranges can be open-ended (at one end only). You can configure whether the lower and upper bounds are inclusive or exclusive.

A range filter is useful for general restrictions that can be shared between searches (like a static date range) because the filter result is cached in memory. Range filters are not appropriate if the range is expected to be different for every query (for example, if the user controls the date range down to the hour via a UI control). Range filters are inclusive by default.

**Example:** ( redemption\_count BETWEEN (0,10\] )

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
range\_filter: {
field: "redemption\_count",
from: 0,
to: 10,
from\_inclusive: false
}
}
}
}

*   `field` (_string_, required) The search field.
*   `from` (_object_) The lower bound of the filter range. If not specified, the range is open-ended with respect to the lower bound. You can't leave both the lower and upper bounds open-ended.
*   `from_inclusive` (_boolean_) Indicates whether the lower bound of the range is inclusive. If not specified, the default is true. Set to false to make the lower bound exclusive.
*   `to` (_object_) The upper bound of the filter range. If not specified, the range is open-ended with respect to the upper bound. You can't leave both the upper and lower bounds open-ended.
*   `to_inclusive` (_boolean_) Indicates whether the upper bound of the range is inclusive. If not specified, the default is true. Set to false to made the upper bound exclusive.

### term\_filter

Document representing a term filter.

A term filter allows you to restrict a search result to hits that match (exactly) one of the values configured for the filter. A term filter is useful for general restrictions that can be shared between searches. Use term filters whenever the criterion you filter on is a shared property of multiple searches (for example, like filtering by an order status). Use term filters for fields that have a discrete and small set of values only.

**Example:** (id="my\_id")

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
term\_filter: {
field: "id",
operator: "is",
values: \["my\_id"\]
}
}
}
}

**Example:** (id IN ("my\_id","other\_id"))

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
term\_filter: {
field: "id",
operator: "one\_of",
values: \["my\_id","other\_id"\]
}
}
}
}

**Example:** (description=NULL)

query: {
filtered\_query: {
query: { match\_all\_query: {} },
filter: {
term\_filter: {
field: "description",
operator: "is\_null"
}
}
}
}

*   `field` (_string_, required) The filter field.
*   `operator` (_string_, required) The operator to compare the field's values with the given ones.  
    Allowed values: `is`, `one_of`, `is_null`, `is_not_null`, `less`, `greater`, `not_in`, `neq`.
*   `values` (_array of object_) The filter values.

### term\_query

A term query matches one (or more) value(s) against one (or more) document field(s). A document is considered a hit if one of the values matches (exactly) with at least one of the given fields. The operator "is" can only take one value, while "one\_of" can take multiple values. If multiple fields are specified, they are combined using the OR operator. The `less` and `greater` operators are not compatible with some search types. To query based on numeric bounds in those cases, you can use a range filter on a filtered query .

**Elastic only** : If used with multiple fields, the query is internally handled as a boolean OR of DisjointMaxQueries (with the dismax matching a value against all fields). The dismax makes sure that a document carrying a single term in multiple fields does not get higher scores than a document matching multiple terms in multiple fields.

**Example:** (id="my\_id")

query: {
term\_query: {
fields: \["id"\],
operator: "is",
values: \["my\_id"\]
}
}

**Example:** (id IN ("my\_id","other\_id"))

query: {
term\_query: {
fields: \["id"\],
operator: "one\_of",
values: \["my\_id","other\_id"\]
}
}

**Example:** (id=null)

query: {
term\_query: {
fields: \["description"\],
operator: "is\_null"
}
}

**Example:** ((id IN ('generic', 'keyword')) OR (description IN ('generic', 'keyword'))

query: {
term\_query: {
fields: \["id", "description"\],
operator: "one\_of",
values: \["generic","keyword"\]
}
}

*   `fields` (_array of string_, required) The document field(s) the value(s) are matched against, combined with the operator.  
    Minimum items: 1.
*   `operator` (_string_, required) Returns the operator to use for the term query.  
    Allowed values: `is`, `one_of`, `is_null`, `is_not_null`, `less`, `greater`, `not_in`, `neq`.
*   `values` (_array of object_) The values the field(s) are compared against, combined with the operator.

### text\_query

A text query is used to match some text (i.e. a search phrase possibly consisting of multiple terms) against one or multiple fields. In case multiple fields are provided, the phrase conceptually forms a logical OR over the fields. In this case, the terms of the phrase basically have to match the text that would result from concatenating all given fields.

**Example:** (coupon\_id contains "xmas" )

query: {
text\_query: {
fields: \["coupon\_id"\],
search\_phrase: "xmas"
}
}

**Example:** (coupon\_id contains "xmas" OR description contains "xmas")

query: {
text\_query: {
fields: \["description", "coupon\_id"\],
search\_phrase: "xmas"
}
}

**Example:** (description contains "holiday" AND description contains "bojo")

query: {
text\_query: {
fields: \["description"\],
search\_phrase: "holiday bogo"
}
}

*   `fields` (_array of string_, required) The document fields the search phrase has to match.  
    Minimum items: 1.
*   `search_phrase` (_string_, required) A search phrase which may consist of multiple terms.